/**
* v_alarmInfo.js
* Version: 0.1
* User: wy
* Date: 2017-09-06
* Copyright(c)  2017. U-GEN Tech.Co,Ltd. All Rights Reserved.
* 报警信息页面
*/
const PAGE_SIZE = 10;
import moment from 'moment';
import config from '../../public/config.js';
import {iot, uPublic, uComponents} from '../../public/public.js';
import projectMethods from '../../public/components.js';

iot.ready(init);
function init() {
    //通用 list、dialog、loading组件
    uPublic.componentsInit(['u-list','u-dialog','u-loading']);
    uPublic.componentsExtend(['list']);
    uPublic.closeSlideBack();
    const app = new Vue({
        data:{            
            //配置组件
            componentsConfig: initComponentsConfig(),
            list:[],
            startId: 0,
            deviceId: null,
            flag: true,
            noticeTipShowFlag: false
        },
        mounted(){      
        	uComponents.showLoading(this);
        	this.noticeTipShowFlag = !iot.native.isNotifycationOpen();
        	resolve(this);
        	window.addEventListener('returnPage',() => {
				this.noticeTipShowFlag = !iot.native.isNotifycationOpen();
			});
        },
        methods:{
        	getList(){
        		return this.list;
        	},
        	setList(list){
        		this.list = list;
        	},
        	getStartId(){
        		return this.startId;
        	},
        	setStartId(id){
        		this.startId = id;
        	},
        	getDeviceId(){
        		return this.deviceId;
        	},
        	setDeviceId(id){
        		this.deviceId = id;
        	},
        	//tap 点击加载更多
        	onListLoad(){
        		listLoad(this);
        	},
        	onRefreshFresh(){
        		refreshFresh(this);
        	},
        	onNotifycationSetting(){
        		notifycationSetting();
        	},
            //tap <
            onBackTap(){
                backTap();
            }                    
        }   
    }).$mount('#app');
}

//配置组件参数
function initComponentsConfig() {
    return {
        alarmInfoList:{   
            initParam: {
                class: 'custom-list',
				list: [],
                tip: Vue.t('alarmInfo.noInfoTip'),
                pagesize: PAGE_SIZE,
                pullup: true
            }
        },
        dialog: {
            initParam: {
                class: 'custom-dialog'
            }
        },
        loading: {
            initParam: {
                class: 'custom-loading'
            }
        }
    }
}

// 获取历史记录
function resolve(self) {
  	self.setDeviceId(iot.navigator.getExtras().deviceId);
//	uComponents.showLoading(self);
	iot.business.api.sendCustom('lock/getHistoryRecord',
	{
		data: {
			device_id: self.getDeviceId(),
			action: 2,
			start_id: self.getStartId(),
			page_size: PAGE_SIZE,
			pullUpLoading: true
		},
		success: async (response) => {
			console.log(response);
			if(self.flag){
				let data = uPublic.checkResponseData(response.data);
				if(data && data.record.length > 0){
					let record = data.record;
					self.flag = await uPublic.upDateRead('notify', moment(record[0].time).unix());
				}
			}
			let data = uPublic.checkResponseData(response.data);
			if(data){
				let list = [];
				let record = data.record;
				for(let i=0; i<record.length; i++){
					list[i] = {
						value: record[i].openId,
//						leftImage: '../../resources/image/green_alarmInfo'+record[i].mode+'_icon.png',
						imgClass: 'u-list-left-bg-alarm_'+record[i].mode,
						subtitle: Vue.t('alarmInfo.'+config.alarmMode[record[i].mode]+''),
						rightText: moment(record[i].time).format("YYYY.MM.DD HH:mm:ss")
					};
				}
				self.setList(self.getList().concat(list));
				if(record.length > 0){
					self.setStartId(record[record.length-1].id);
				}
				//更新列表数据
	            projectMethods.changeList(self, self.getList());
			}else{
			}
			uComponents.hideLoading(self);
		},
		error: (error) => {
			console.log(error); 
           	uPublic.openRequestErrorAlert(self);
		},
		complete: () => {
			uComponents.hideLoading(self);
		}
	});
}

//tap <
function backTap(){
   iot.navigator.aback();
}

//重写mui.back
//mui.back = function(){
//  iot.navigator.fire(plus.webview.currentWebview().opener(),'returnPage',{});
//  console.log("fire");
//	iot.navigator.back();
//}

//tap 点击加载更多
function listLoad(self) {
	resolve(self);
}

//ios跳转到系统设置页面
//android跳转到通知页面
function notifycationSetting(){
	if(plus.os.name == 'Android'){
//		alert("打开通知页面");
		iot.navigator.openWindow({
	        url: './notify.html',
	        id: 'notify',
	        styles: {
	        	popGesture: 'none'
	        }
	    });
	}else{
		iot.native.toNotifycationSetting();
	}
}
